unit Odchoose;

interface

uses
  SysUtils, WinTypes, WinProcs, Messages, Classes, Graphics, Controls,
  Forms, Dialogs, Buttons, ExtCtrls, StdCtrls, ODLed, DsgnIntF, TypInfo;


type
  TODChooseDlg = class(TForm)
    BitBtn1: TBitBtn;
    SpeedButton1: TSpeedButton;
    SpeedButton3: TSpeedButton;
    SpeedButton5: TSpeedButton;
    SpeedButton7: TSpeedButton;
    SpeedButton9: TSpeedButton;
    SpeedButton11: TSpeedButton;
    SpeedButton13: TSpeedButton;
    SpeedButton14: TSpeedButton;
    SpeedButton12: TSpeedButton;
    SpeedButton10: TSpeedButton;
    SpeedButton8: TSpeedButton;
    SpeedButton6: TSpeedButton;
    SpeedButton4: TSpeedButton;
    SpeedButton2: TSpeedButton;
    BitBtn2: TBitBtn;
    procedure SpeedButton1Click(Sender: TObject);
    procedure FormCreate(Sender: TObject);
  private
    { Private declarations }
    FLed      : TLedLittleColor;
    procedure SetLed(NewLed: TLedLittleColor);
  public
    { Public declarations }
    property LedColor: TLedLittleColor read FLed write SetLed;
  end;

  TLedLittleProperty = class( TEnumProperty )
       function GetAttributes: TPropertyAttributes; override;
       procedure Edit; override;
  end;

var
  ODChooseDlg: TODChooseDlg;

implementation

{$R *.DFM}

procedure TODChooseDlg.SpeedButton1Click(Sender: TObject);
begin
    FLed := TLedLittleColor((Sender as TSpeedButton).Tag);
end;

procedure TODChooseDlg.FormCreate(Sender: TObject);
begin
    SpeedButton1.Down := True;
end;

procedure TODChooseDlg.SetLed(NewLed: TLedLittleColor);
var
    Counter: Integer;
begin
    FLed := NewLed;
    for Counter := 0 to ComponentCount - 1 do
        if (Components[Counter] is TSpeedButton) then
            if TSpeedButton(Components[Counter]).Tag = Ord(Newled) then
                TSpeedButton(Components[Counter]).Down := True;
end;

{---------Property Editor Stuff--------------}

function TLedLittleProperty.GetAttributes: TPropertyAttributes;
begin
    Result := [paDialog];
end;

procedure TLedLittleProperty.Edit;
var
    ODChooseDlg: TODChooseDlg;
begin
    ODChooseDlg := TODChooseDlg.Create(Application);
    try
        ODChooseDlg.LedColor := TLedLittleColor(GetOrdValue);
        if ODChooseDlg.ShowModal = mrOK then
            SetOrdValue(Ord(ODChooseDlg.LedColor));
    finally
        ODChooseDlg.Free
    end;
end;

end.
